added --enable-xvfb and other configure options [release 1.20.5-2mamba;Sat Sep 07 2019]

This commit is contained in:
Silvan Calarco 2024-01-05 19:48:57 +01:00
parent 80f3cd3da9
commit f8a5dd3491
3 changed files with 527 additions and 13 deletions

200
xorg-server-xvfb-run Normal file
View File

@ -0,0 +1,200 @@
#!/bin/sh
# --- T2-COPYRIGHT-NOTE-BEGIN ---
# This copyright note is auto-generated by ./scripts/Create-CopyPatch.
#
# T2 SDE: package/.../xorg-server/xvfb-run.sh
# Copyright (C) 2005 The T2 SDE Project
# Copyright (C) XXXX - 2005 Debian
#
# More information can be found in the files COPYING and README.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License. A copy of the
# GNU General Public License can be found in the file COPYING.
# --- T2-COPYRIGHT-NOTE-END ---
# $Id$
# from: http://necrotic.deadbeast.net/xsf/XFree86/trunk/debian/local/xvfb-run
# This script starts an instance of Xvfb, the "fake" X server, runs a command
# with that server available, and kills the X server when done. The return
# value of the command becomes the return value of this script.
#
# If anyone is using this to build a Debian package, make sure the package
# Build-Depends on xvfb, xbase-clients, and xfonts-base.
set -e
PROGNAME=xvfb-run
SERVERNUM=99
AUTHFILE=
ERRORFILE=/dev/null
STARTWAIT=3
XVFBARGS="-screen 0 640x480x24"
LISTENTCP="-nolisten tcp"
XAUTHPROTO=.
# Query the terminal to establish a default number of columns to use for
# displaying messages to the user. This is used only as a fallback in the event
# the COLUMNS variable is not set. ($COLUMNS can react to SIGWINCH while the
# script is running, and this cannot, only being calculated once.)
DEFCOLUMNS=$(stty size 2>/dev/null | awk '{print $2}') || true
if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" >/dev/null 2>&1; then
DEFCOLUMNS=80
fi
# Display a message, wrapping lines at the terminal width.
message () {
echo "$PROGNAME: $*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS}
}
# Display an error message.
error () {
message "error: $*" >&2
}
# Display a usage message.
usage () {
if [ -n "$*" ]; then
message "usage error: $*"
fi
cat <<EOF
Usage: $PROGNAME [OPTION ...] COMMAND
Run COMMAND (usually an X client) in a virtual X server environment.
Options:
-a --auto-servernum try to get a free server number, starting at
--server-num (deprecated, use --auto-display
instead)
-d --auto-display use the X server to find a display number
automatically
-e FILE --error-file=FILE file used to store xauth errors and Xvfb
output (default: $ERRORFILE)
-f FILE --auth-file=FILE file used to store auth cookie
(default: ./.Xauthority)
-h --help display this usage message and exit
-n NUM --server-num=NUM server number to use (default: $SERVERNUM)
-l --listen-tcp enable TCP port listening in the X server
-p PROTO --xauth-protocol=PROTO X authority protocol name to use
(default: xauth command's default)
-s ARGS --server-args=ARGS arguments (other than server number and
"-nolisten tcp") to pass to the Xvfb server
(default: "$XVFBARGS")
-w DELAY --wait=DELAY delay in seconds to wait for Xvfb to start
before running COMMAND (default: $STARTWAIT)
EOF
}
# Find a free server number by looking at .X*-lock files in /tmp.
find_free_servernum() {
# Sadly, the "local" keyword is not POSIX. Leave the next line commented in
# the hope Debian Policy eventually changes to allow it in /bin/sh scripts
# anyway.
#local i
i=$SERVERNUM
while [ -f /tmp/.X$i-lock ]; do
i=$(($i + 1))
done
echo $i
}
# Parse the command line.
ARGS=$(getopt --options +ade:f:hn:lp:s:w: \
--long auto-servernum,error-file:auth-file:,help,server-num:,listen-tcp,xauth-protocol:,server-args:,wait: \
--name "$PROGNAME" -- "$@")
GETOPT_STATUS=$?
if [ $GETOPT_STATUS -ne 0 ]; then
error "internal error; getopt exited with status $GETOPT_STATUS"
exit 6
fi
eval set -- "$ARGS"
while :; do
case "$1" in
-a|--auto-servernum) SERVERNUM=$(find_free_servernum) ;;
-d|--auto-display) AUTO_DISPLAY=1 ;;
-e|--error-file) ERRORFILE="$2"; shift ;;
-f|--auth-file) AUTHFILE="$2"; shift ;;
-h|--help) SHOWHELP="yes" ;;
-n|--server-num) SERVERNUM="$2"; shift ;;
-l|--listen-tcp) LISTENTCP="" ;;
-p|--xauth-protocol) XAUTHPROTO="$2"; shift ;;
-s|--server-args) XVFBARGS="$2"; shift ;;
-w|--wait) STARTWAIT="$2"; shift ;;
--) shift; break ;;
*) error "internal error; getopt permitted \"$1\" unexpectedly"
exit 6
;;
esac
shift
done
if [ "$SHOWHELP" ]; then
usage
exit 0
fi
if [ -z "$*" ]; then
usage "need a command to run" >&2
exit 2
fi
if ! type xauth >/dev/null; then
error "xauth command not found"
exit 3
fi
# Set up the temp dir for the pid and X authorization file
XVFB_RUN_TMPDIR="$(mktemp --directory --tmpdir $PROGNAME.XXXXXX)"
# If the user did not specify an X authorization file to use, set up a temporary
# directory to house one.
if [ -z "$AUTHFILE" ]; then
AUTHFILE=$(mktemp -p "$XVFB_RUN_TMPDIR" Xauthority.XXXXXX)
fi
# Start Xvfb.
MCOOKIE=$(mcookie)
if [ -z "$AUTO_DISPLAY" ]; then
# Old style using a pre-computed SERVERNUM
XAUTHORITY=$AUTHFILE Xvfb ":$SERVERNUM" $XVFBARGS $LISTENTCP >>"$ERRORFILE" \
2>&1 &
XVFBPID=$!
else
# New style using Xvfb to provide a free display
PIDFILE=$(mktemp -p "$XVFB_RUN_TMPDIR" pid.XXXXXX)
SERVERNUM=$(XAUTHORITY=$AUTHFILE Xvfb -displayfd 1 $XVFBARGS $LISTENTCP \
2>"$ERRORFILE" & echo $! > $PIDFILE)
XVFBPID=$(cat $PIDFILE)
fi
sleep "$STARTWAIT"
XAUTHORITY=$AUTHFILE xauth source - << EOF >>"$ERRORFILE" 2>&1
add :$SERVERNUM $XAUTHPROTO $MCOOKIE
EOF
# Start the command and save its exit status.
set +e
DISPLAY=:$SERVERNUM XAUTHORITY=$AUTHFILE "$@" 2>&1
RETVAL=$?
set -e
# Kill Xvfb now that the command has exited.
kill $XVFBPID
# Clean up.
XAUTHORITY=$AUTHFILE xauth remove ":$SERVERNUM" >"$ERRORFILE" 2>&1
if [ -n "$XVFB_RUN_TMPDIR" ]; then
if ! rm -r "$XVFB_RUN_TMPDIR"; then
error "problem while cleaning up temporary directory"
exit 5
fi
fi
# Return the executed command's exit status.
exit $RETVAL
# vim:set ai et sts=4 sw=4 tw=80:

282
xorg-server-xvfb-run.1 Normal file
View File

@ -0,0 +1,282 @@
.\" $Id: xvfb-run.1 2138 2005-01-17 23:40:27Z branden $
.\"
.\" Copyright 1998-2004 Branden Robinson <branden@debian.org>.
.\"
.\" This is free software; you may redistribute it and/or modify
.\" it under the terms of the GNU General Public License as
.\" published by the Free Software Foundation; either version 2,
.\" or (at your option) any later version.
.\"
.\" This is distributed in the hope that it will be useful, but
.\" WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public License with
.\" the Debian operating system, in /usr/share/common-licenses/GPL; if
.\" not, write to the Free Software Foundation, Inc., 59 Temple Place,
.\" Suite 330, Boston, MA 02111-1307 USA
.\"
.\" We need the URL macro from groff's www macro package, but also want
.\" things to work all right for people who don't have it. So we define
.\" our own URL macro and let the www macro package override it if it's
.\" available.
.de URL
\\$2 \(laURL: \\$1 \(ra\\$3
..
.if \n[.g] .mso www.tmac
.TH xvfb\-run 1 "2004\-11\-12" "Debian Project"
.SH NAME
xvfb\-run \- run specified X client or command in a virtual X server environment
.SH SYNOPSIS
.B xvfb\-run
[
.I options
]
.I command
.SH DESCRIPTION
.B xvfb\-run
is a wrapper for the
.BR Xvfb (1x)
command which simplifies the task of running commands (typically an X
client, or a script containing a list of clients to be run) within a virtual
X server environment.
.PP
.B xvfb\-run
sets up an X authority file (or uses an existing user\-specified one),
writes a cookie to it (see
.BR xauth (1x))
and then starts the
.B Xvfb
X server as a background process.
The process ID of
.B Xvfb
is stored for later use.
The specified
.I command
is then run using the X display corresponding to the
.B Xvfb
server
just started and the X authority file created earlier.
.PP
When the
.I command
exits, its status is saved, the
.B Xvfb
server is killed (using the process ID stored earlier), the X authority
cookie removed, and the authority file deleted (if the user did not specify
one to use).
.B xvfb\-run
then exits with the exit status of
.IR command .
.PP
.B xvfb\-run
requires the
.B xauth
command to function.
.SH OPTIONS
.TP
.B \-a\fR,\fB \-\-auto\-servernum
Try to get a free server number, starting at 99, or the argument to
.BR \-\-server\-num .
.TP
.BI \-e\ file \fR,\fB\ \-\-error\-file= file
Store output from
.B xauth
and
.B Xvfb
in
.IR file .
The default is
.IR /dev/null .
.TP
.BI \-f\ file \fR,\fB\ \-\-auth\-file= file
Store X authentication data in
.IR file .
By default, a temporary directory called
.IR xvfb\-run. PID
(where PID is the process ID of
.B xvfb\-run
itself) is created in the directory specified by the environment variable
.B TMPDIR
(or
.I /tmp
if that variable is null or unset), and the
.BR tempfile (1)
command is used to create a file in that temporary directory called
.IR Xauthority .
.TP
.B \-h\fR,\fB \-\-help
Display a usage message and exit.
.TP
.BI \-n\ servernumber \fR,\fB\ \-\-server\-num= servernumber
Use
.I servernumber
as the server number (but see the
.B \-a\fR,\fB \-\-auto\-servernum
option above).
The default is 99.
.TP
.B \-l\fR,\fB \-\-listen\-tcp
Enable TCP port listening in the X server.
For security reasons (to avoid denial\-of\-service attacks or exploits),
TCP port listening is disabled by default.
.TP
.BI \-p\ protocolname \fR,\fB\ \-\-xauth\-protocol= protocolname
Use
.I protocolname
as the X authority protocol to use.
The default is \(oq.\(cq, which
.B xauth
interprets as its own default protocol, which is MIT\-MAGIC\-COOKIE\-1.
.TP
.BI \-s\ arguments \fR,\fB\ \-\-server\-args= arguments
Pass
.I arguments
to the
.B Xvfb
server.
Be careful to quote any whitespace characters that may occur within
.I arguments
to prevent them from regarded as separators for
.BR xvfb\-run 's
own arguments.
Also, note that specification of \(oq\-nolisten tcp\(cq in
.I arguments
may override the function of
.BR xvfb\-run 's
own
.B \-l\fR,\fB \-\-listen\-tcp
option, and that specification of the server number (e.g., \(oq:1\(cq) may
be ignored because of the way the X server parses its argument list.
Use the
.B xvfb\-run
option
.BI \-n\ servernumber \fR,\fB\ \-\-server\-num= servernumber
to achieve the latter function.
The default is \(oq\-screen 0 640x480x8\(cq.
.TP
.BI \-w\ delay \fR,\fB\ \-\-wait= delay
Wait
.I delay
seconds after launching
.B Xvfb
before attempting to start the specified command.
The default is 3.
.SH ENVIRONMENT
.TP
.B COLUMNS
indicates the width of the terminal device in character cells.
This value is used for formatting diagnostic messages.
If not set, the terminal is queried using
.BR stty (1)
to determine its width.
If that fails, a value of \(oq80\(cq is assumed.
.TP
.B TMPDIR
specifies the directory in which to place
.BR xvfb\-run 's
temporary directory for storage of the X authority file; only used if the
.B \-f
or
.B \-\-auth\-file
options are not specified.
.SH "OUTPUT FILES"
.PP
Unless the
.B \-f
or
.B \-\-auth\-file
options are specified, a temporary
directory and file within it are created (and deleted) to store the X
authority cookies used by the
.B Xvfb
server and client(s) run under it.
See
.BR tempfile (1).
If \-f or \-\-auth\-file are used, then the specified X authority file is
only written to, not created or deleted (though
.B xauth
creates an authority file itself if told to use use that does not already
exist).
.PP
An error file with a user\-specified name is also created if the
.B \-e
or
.B \-\-error\-file
options are specifed; see above.
.SH "EXIT STATUS"
.B xvfb\-run
uses its exit status as well as output to standard error to communicate
diagnostics.
The exit status of \(oq1\(cq is not used, and should be interpreted as failure
of the specified command.
.TP
0
.B xvfb\-run
only uses this exit status if the
.B \-h\fR,\fB \-\-help
option is given.
In all other situations, this may be interpreted as success of the specified
command.
.TP
2
No command to run was specified.
.TP
3
The
.B xauth
command is not available.
.TP
4
The temporary directory that was going to be used already exists; since
.B xvfb\-run
produces a uniquely named directory, this may indicate an attempt by another
process on the system to exploit a temporary file race condition.
.TP
5
A problem was encountered while cleaning up the temporary directory.
.TP
6
A problem was encountered while using
.BR getopt (1)
to parse the command\-line arguments.
.SH EXAMPLES
.TP
.B xvfb\-run \-\-auto\-servernum \-\-server\-num=1 xlogo
runs the
.BR xlogo (1x)
demonstration client inside the
.B Xvfb
X server on the first available server number greater than or equal to 1.
.TP
.B xvfb\-run \-\-server\-args="\-screen 0 1024x768x24" ico \-faces
runs the
.BR ico (1x)
demonstration client (and passes it the
.B \-faces
argument) inside the
.B Xvfb
X server, configured with a root window of 1024 by 768 pixels and a color
depth of 24 bits.
.PP
Note that the demo X clients used in the above examples will not exit on
their own, so they will have to be killed before
.B xvfb\-run
will exit.
.SH BUGS
See
.URL "http://bugs.debian.org/xvfb" "the Debian Bug Tracking System" .
If you wish to report a bug in
.BR xvfb\-run ,
please use the
.BR reportbug (1)
command.
.SH AUTHOR
.B xfvb\-run
was written by Branden Robinson and Jeff Licquia with sponsorship from
Progeny Linux Systems.
.SH "SEE ALSO"
.BR Xvfb (1x),
.BR xauth (1x)
.\" vim:set et tw=80:

View File

@ -1,6 +1,6 @@
Name: xorg-server
Version: 1.20.5
Release: 1mamba
Release: 2mamba
Summary: The core of the X.Org Foundation implementation of the X Window system
Group: System/X11
Vendor: openmamba
@ -8,6 +8,8 @@ Distribution: openmamba
Packager: Silvan Calarco <silvan.calarco@mambasoft.it>
URL: http://www.x.org
Source: ftp://x.org/pub/individual/xserver/xorg-server-%{version}.tar.bz2
Source1: xorg-server-xvfb-run
Source2: xorg-server-xvfb-run.1
Source10: XFree86-skel-.xinitrc
Source11: xorg-server-xprofile
Patch0: xorg-server-1.16-Xorg_configure.patch
@ -60,21 +62,20 @@ BuildRequires: libwayland-devel
BuildRequires: libxcb-devel
BuildRequires: libxshmfence-devel
BuildRequires: libz-devel
## AUTOBUILDREQ-END
BuildRequires: xorgproto-devel
## AUTOBUILDREQ-END
BuildRequires: xorg-xtrans-devel >= 1.0.0
BuildRequires: libXRes-devel >= 1.0.1
BuildRequires: libGL-devel >= 6.5.2
BuildRequires: perl-devel >= 5.8.8
BuildRequires: libpciaccess-devel
%ifarch %{ix86} x86_64
BuildRequires: libsmbios-devel
%endif
BuildRequires: systemd-devel
BuildRequires: presentproto-devel
BuildRequires: font-util
BuildRequires: graphviz
BuildRequires: systemtap-sdt-devel
BuildRequires: libegl-wayland-devel
Requires: xorgdrvinput
Requires: xorgdrvvideo
Requires: xorg-fonts-base
@ -124,6 +125,14 @@ Group: System/X11
%description dmx
X.Org dmx server.
%package xvfb
Summary: X.Org server virtual framebuffer
Group: System/X11
Requires: %{name} = %{?epoch:%epoch:}%{version}-%{release}
%description xvfb
X.Org server virtual framebuffer.
%package -n xorg-ext-libglx
Summary: X.Org glx extension
Group: System/X11
@ -148,6 +157,8 @@ X.org generic modesetting driver.
%prep
%setup -q -n %{name}-%{version}
#-D -T
#:<< _EOF
#%patch0 -p1
#%patch1 -p1
#%patch2 -p1
@ -156,6 +167,7 @@ X.org generic modesetting driver.
%endif
%build
#:<< _EOF
%ifarch arm
autoreconf -i || true
%endif
@ -165,6 +177,17 @@ X.org generic modesetting driver.
--enable-xdmcp \
--enable-dmx \
--enable-xdm-auth-1 \
--enable-xvfb \
--enable-xnest \
--enable-xcsecurity \
--enable-xorg \
--enable-xwayland \
--enable-xwayland_eglstream \
--enable-glamor \
--enable-udev \
--enable-suid_wrapper \
--enable-systemd-logind \
--enable-ipv6 \
--with-xkb-output=%{_sysconfdir}/X11/xkb/compiled \
--with-os-name="Linux" \
--with-os-vendor="openmamba" \
@ -184,6 +207,9 @@ X.org generic modesetting driver.
install -d %{buildroot}%{_sysconfdir}/skel %{buildroot}%{_sysconfdir}/xprofile.d
install -d -m0755 %{buildroot}%{_sysconfdir}/X11/xorg.conf.d
install -D -m0755 %{SOURCE1} %{buildroot}%{_bindir}/xvfb-run
install -D -m0644 %{SOURCE2} %{buildroot}%{_mandir}/man1/xvfb-run.1
cp %{SOURCE10} %{buildroot}%{_sysconfdir}/skel/.xinitrc
install -m 755 %{SOURCE11} %{buildroot}%{_sysconfdir}/xprofile
@ -281,24 +307,24 @@ exit 0
%dir %{_libdir}/xorg/modules
%{_libdir}/xorg/modules/lib*.la
%{_libdir}/xorg/modules/lib*.so
#%{_libdir}/xorg/modules/linux/*
#%{_libdir}/xorg/modules/multimedia/*
%{_libdir}/xorg/protocol.txt
#%{_libdir}/xserver/SecurityPolicy
%{_libexecdir}/Xorg
%{_libexecdir}/Xorg.wrap
%dir %{_datadir}/X11
%dir %{_datadir}/X11/xorg.conf.d
#%{_datadir}/X11/xorg.conf.d/10-evdev.conf
%{_datadir}/X11/xorg.conf.d/10-quirks.conf
%{_mandir}/man1/cvt.1*
%{_mandir}/man1/gtf.1*
%{_mandir}/man1/Xnest.1*
%{_mandir}/man1/Xorg.1*
%{_mandir}/man1/Xorg.wrap.1*
%{_mandir}/man1/Xserver.1*
%{_mandir}/man1/Xvfb.1*
%{_mandir}/man4/exa.4*
%{_mandir}/man4/fbdevhw.4*
%{_mandir}/man5/xorg.conf.5*
%{_mandir}/man5/xorg.conf.d.5*
%{_mandir}/man5/Xwrapper.config.5*
%doc COPYING
%files dmx
@ -320,10 +346,13 @@ exit 0
%{_mandir}/man1/vdltodmx.1*
%{_mandir}/man1/xdmxconfig.1*
%files xvfb
%defattr(-,root,root)
%{_bindir}/xvfb-run
%{_mandir}/man1/xvfb-run.1*
%files devel
%defattr(-,root,root)
#%{_includedir}/X11/bitmaps/*
#%{_includedir}/X11/pixmaps/*
%dir %{_includedir}/xorg
%{_includedir}/xorg/*.h
%{_libdir}/pkgconfig/*.pc
@ -344,6 +373,9 @@ exit 0
%{_libdir}/xorg/glx-dri/libglx.so
%changelog
* Sat Sep 07 2019 Silvan Calarco <silvan.calarco@mambasoft.it> 1.20.5-2mamba
- added --enable-xvfb and other configure options
* Fri May 31 2019 Automatic Build System <autodist@mambasoft.it> 1.20.5-1mamba
- automatic version update by autodist
@ -391,13 +423,13 @@ exit 0
* Mon Mar 09 2015 Automatic Build System <autodist@mambasoft.it> 1.17.1-1mamba
- automatic version update by autodist
* Sun Sep 21 2014 Automatic Build System <autodist@mambasoft.it> 1.16.1-1mamba
* Sat Dec 27 2014 Automatic Build System <autodist@mambasoft.it> 1.16.1-1mamba
- automatic version update by autodist
* Sun Aug 31 2014 Automatic Build System <autodist@mambasoft.it> 1.16.0-1mamba
* Sat Dec 20 2014 Automatic Build System <autodist@mambasoft.it> 1.16.0-1mamba
- automatic version update by autodist
* Sat May 23 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 1.15.2-7mamba
* Sat Dec 13 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 1.15.2-7mamba
- install libglx.so out of xorg/modules tree for server to pick right alternative
* Sat Dec 06 2014 Silvan Calarco <silvan.calarco@mambasoft.it> 1.15.2-6mamba